MODULE bruch EXPORTS Main;
IMPORT IO;

VAR zaehler, nenner : INTEGER;            (* Komponenten des Bruches *)
VAR teiler: CARDINAL;

(*-------------------------------------------------------------------*)
(* Prozedur ggT, liest Argumente: zaehler =x, nenner =y als Werte,   *)
(* gibt zurueck: groessten gemeinsamen Teiler von x und y            *)
(*-------------------------------------------------------------------*)

PROCEDURE ggT (VALUE x,y : INTEGER) :CARDINAL =

BEGIN
  y:=ABS(y); (* Vorzeichen sind fuer Berechnung unwichtig: eliminieren *)
  x:=ABS(x);

  (* Loesungsalgorithmus nach Euklid *)
  WHILE x#y DO
    IF x>y THEN DEC(x,y) ELSE DEC(y,x) END;
  END;

  RETURN x
END ggT;

(*-------------------------------------------------------------------*)
(* Prozedur ReduceFraction, nimmt Argumente: zaehler =x, nenner =y   *)
(* als Variablen, berechnet den gekuerzten Bruch durch Division mit  *)
(* dem groessten gemeinsamen Teiler                                  *)
(*  Aufrufe: ReduceFraction -> ggT                                   *) 
(*-------------------------------------------------------------------*)

PROCEDURE ReduceFraction (VAR x,y : INTEGER) =

BEGIN

  teiler:= ggT(x,y);
  x:= x DIV teiler;
  y:= y DIV teiler;
  IF y<0 THEN x:= -x END; (* ist Nenner negativ, aendert sich das Vorzeichen *)

END ReduceFraction;

(*-------------------------------------------------------------------*)
(* Prozedur PutFraction, nimmt Argumente: zaehler =x, nenner =y      *)
(* als Werte, keine Rueckgabewerte. Gibt gekuerzten Bruch aus.       *)
(*  Aufrufe: PutFraction -> ReduceFraction -> ggT                    *) 
(*-------------------------------------------------------------------*)

PROCEDURE PutFraction(VALUE x,y : INTEGER) =

BEGIN

  ReduceFraction(x,y);

  IO.PutInt(x);
  IF ABS(y)>1 THEN
    IO.Put("/");
    IO.PutInt(ABS(y));
  END;

  IO.Put("\n");

END PutFraction;

(*********************************************************************)
(* Programm Bruch liest 2 Zahlen ein und gibt diese als gekuerzten   *)
(* Bruch aus.                                                        *)
(*  Aufrufe: BRUCH -> PutFraction -> ReduceFraction -> ggT           *) 
(*********************************************************************)

BEGIN

IO.Put("Bitte geben sie den Zaehler ein: ");
zaehler:= IO.GetInt();
IO.Put("Bitte geben sie nun den Nenner ein: ");
nenner:= IO.GetInt();

IO.Put("Der gekuerzte Bruch lautet: ");
PutFraction(zaehler,nenner);

END bruch.









