MODULE int EXPORTS Main;
IMPORT IO;

EXCEPTION OutOfRange;
VAR Min, Max, Zahla, Zahlb, Eingabe : INTEGER;

PROCEDURE GetIntInIntervall(VALUE a,b : INTEGER) : INTEGER
RAISES {OutOfRange} =

BEGIN

  TRY
      Eingabe:= IO.GetInt();
      EVAL IO.GetLine();
      IF Eingabe<a OR Eingabe>b THEN RAISE OutOfRange END;
  EXCEPT
    |IO.Error =>
      IO.Put("\nFalsche Eingabe: bitte eine ganze Zahl eingeben.\n");
      EVAL IO.GetLine();            (* faengt falsche Zeichen auf *)
      RETURN GetIntInIntervall(a,b);
  END;

  RETURN Eingabe;

END GetIntInIntervall;

PROCEDURE Addition(VALUE a,b : INTEGER) RAISES{OutOfRange} =

BEGIN

  IO.Put("\nBitte geben sie eine erste Zahl an:");
  Zahla:= GetIntInIntervall(a,b);

  IO.Put("Bitte geben sie eine zweite Zahl an:");
  Zahlb:= GetIntInIntervall(a,b);

  INC(Zahla,Zahlb);
  IF Zahla<a OR Zahlb>b THEN RAISE OutOfRange END;
  IO.Put("\nErgebnis:");
  IO.PutInt(Zahla); IO.Put("\n");

END Addition;

PROCEDURE Subtraktion(VALUE a,b : INTEGER) RAISES{OutOfRange} =

BEGIN

  IO.Put("\nBitte geben sie eine erste Zahl an:");
  Zahla:= GetIntInIntervall(a,b);

  IO.Put("Bitte geben sie eine zweite Zahl an:");
  Zahlb:= GetIntInIntervall(a,b);

  DEC(Zahla,Zahlb);
  IF Zahla<a OR Zahlb>b THEN RAISE OutOfRange END;
  IO.Put("\nErgebnis:");
  IO.PutInt(Zahla); IO.Put("\n");

END Subtraktion;

BEGIN

  Min:= FIRST(INTEGER); Max:= LAST(INTEGER);
  IO.Put("\nGegenwaertiges Intervall: ");
  IO.PutInt(Min); IO.Put(" : "); IO.PutInt(Max); IO.Put("\n");

  LOOP

    IO.Put("\n(1) INTERVALL FESTLEGEN");
    IO.Put("\n(2) SUMME");
    IO.Put("\n(3) DIFFERENZ");
    IO.Put("\n(4) ENDE\n");
    LOOP
      TRY
        Eingabe:= GetIntInIntervall(1,4);
        EXIT
      EXCEPT
         |OutOfRange =>
           IO.Put("\nEingegebener Wert ist kein Menuepunkt.\n");
      END;
    END;

    IF Eingabe= 1 THEN
      LOOP
       TRY
         IO.Put("Bitte geben sie ein Minimum an:"); 
         Min:= GetIntInIntervall(FIRST(INTEGER),LAST(INTEGER));
         EXIT
       EXCEPT
         |OutOfRange =>
           IO.Put("\nEingegebener Wert liegt ausserhalb des Intervalls:\n");
           IO.PutInt(FIRST(INTEGER)); IO.Put(" : ");
           IO.PutInt(LAST(INTEGER)); IO.Put("\n");
       END;
      END;

      LOOP
       TRY
         IO.Put("Bitte geben sie ein Maximum an:");
         Max:= GetIntInIntervall(Min,LAST(INTEGER));
         EXIT
       EXCEPT
         |OutOfRange =>
           IO.Put("\nEingegebener Wert liegt ausserhalb des Intervalls:\n");
           IO.PutInt(Min); IO.Put(" : ");
           IO.PutInt(LAST(INTEGER)); IO.Put("\n");
       END;
      END;
    ELSIF Eingabe= 2 THEN
      TRY
        Addition(Min,Max);
      EXCEPT
        |OutOfRange => IO.Put("\nWert liegt ausserhalb des Intervalls\n");
          IO.PutInt(Min); IO.Put(" : "); IO.PutInt(Max); IO.Put("\n");
      END;
    ELSIF Eingabe= 3 THEN
      TRY
        Subtraktion(Min,Max);
      EXCEPT
        |OutOfRange => IO.Put("\nWert liegt ausserhalb des Intervalls\n");
          IO.PutInt(Min); IO.Put(" : "); IO.PutInt(Max); IO.Put("\n");
      END;
    ELSIF Eingabe= 4 THEN
      EXIT
    END;

  END;

END int.




























