MODULE Matrix;
IMPORT IO;

(*-------------------------------------------------------------------*)
(* Prozedur Init, uebernimmt Matrix: a, keine Rueckgabewerte, erzeugt*)
(* symmetrische Matrix, Elemente erhalten jew. Summe aus Zeilen- und *)
(* Spaltenindex.                                                     *)
(*-------------------------------------------------------------------*)

PROCEDURE Init(VAR a : T) =

BEGIN

 FOR i:=1 TO n DO

  FOR j:=1 TO n DO

   a[i,j]:= i+j;

  END;

 END;

END Init;


(*-------------------------------------------------------------------*)
(* Prozedur Put, liest Matrix: a, keine Rueckgabewerte, gibt Elemente*)
(* durch Tabulatoren getrennt aus.                                   *)
(*-------------------------------------------------------------------*)

PROCEDURE Put(READONLY a : T) =

BEGIN

 FOR i:=1 TO n DO

  FOR j:=1 TO n DO

   IO.PutInt(a[i,j]);
   IO.Put("\t");

  END;

   IO.Put("\n");

 END;
END Put;

(*-------------------------------------------------------------------*)
(* Prozedur Add, liest Matritzen: a,b als Werte, uebernimmt Matrix c,*)
(* keine Rueckgabewerte, formt um: c in Summe von a und b.           *)
(*-------------------------------------------------------------------*)

PROCEDURE Add(READONLY a,b : T; VAR c : T) =

BEGIN


 FOR i:=1 TO n DO

  FOR j:=1 TO n DO

   c[i,j]:= a[i,j]+b[i,j];

  END;

 END;
END Add;


(*-------------------------------------------------------------------*)
(* Prozedur ScalarProd, liest Matrix: a als Wert, liest Argument: b, *)
(* uebernimmt Matrix c, keine Rueckgabewerte, formt um: c in Produkt *)
(* der Elemente aus a multipliziert b                                *)
(*-------------------------------------------------------------------*)

PROCEDURE ScalarProd(READONLY a: T;READONLY b : INTEGER; VAR c : T) =

BEGIN

 FOR i:=1 TO n DO

  FOR j:=1 TO n DO

   c[i,j]:= a[i,j]*b;

  END;

 END;

END ScalarProd;


(*-------------------------------------------------------------------*)
(* Prozedur Mult, liest Matritzen: a,b als Werte, uebernimmt Matr. c,*)
(* keine Rueckgabewerte, formt um: c in Produkt der Matritzen a und b*)
(*-------------------------------------------------------------------*)

PROCEDURE Mult(READONLY x,y : T; VAR c : T) =


VAR a,b : T;

BEGIN


a:=x;b:=y;

 FOR i:=1 TO n DO

  FOR j:=1 TO n DO

    FOR k:=1 TO n DO

      IF k=1 THEN c[i,j]:=0 END;

      INC(c[i,j],a[i,k]*b[k,j]);

    END;

  END;

 END;

END Mult;

BEGIN

END Matrix.
