MODULE Main;

IMPORT IO,BinaryTree;

VAR x : INTEGER;
VAR element, tree : BinaryTree.RefT;
VAR Wahl : CHAR;

(*********************************************************************)
(* Hauptprogramm zu Aufgabe 9,                                       *)
(* Fuegt Elemente in einen bin. Baunm ein, oder entfernt diese.      *)
(* Sucht Elemente, gibt Minima/Maxima aus, gibt Baum zurueck.        *)
(* Aufruf ueber Menuesteuerung.                                      *)
(*  Aufrufe:                                                         *)
(* -> insert                                                         *)
(* -> delete                                                         *)
(* -> search                                                         *)
(* -> minimum                                                        *)
(* -> maximum                                                        *)
(* -> put                                                            *)
(*********************************************************************)

BEGIN

  LOOP
    IF Wahl= '7' THEN EXIT; END; (* Beenden bei Benutzerwahl *)

    IO.Put("\n[1] Einfuegen\n");
    IO.Put("[2] Loeschen\n");
    IO.Put("[3] Suche\n");
    IO.Put("[4] Minimum\n");
    IO.Put("[5] Maximum\n");
    IO.Put("[6] Ausgabe\n");
    IO.Put("[7] Beenden des Programms\n");

    Wahl:= IO.GetChar();
    EVAL IO.GetLine();
    (**Ereignisbehandlung**)
    (* Wenn '1', dann Wert einlesen und Element hinzufuegen.    *)
    (* Wenn '2', dann Wert einlesen, suchen, Element entfernen. *)
    (* Wenn '3', dann Wert einlesen, suchen, Element ausgeben.  *)
    (* Wenn '4', dann Minimum suchen, Element ausgeben.         *)
    (* Wenn '5', dann Maximum suchen, Element ausgeben.         *)
    (* Wenn '6', dann Baum nach Groesse geordnet ausgeben.      *)
    CASE Wahl OF
    | '1' =>

      (* Wiederhole bis Erfolg: neues Element einlesen *)
      LOOP
        IO.Put("\nBitte geben sie das neue Element ein: ");
        TRY
          x:= IO.GetInt();
          EVAL IO.GetLine();
          EXIT
        EXCEPT
          | IO.Error => IO.Put("Ungueltiger Wert.\n");
            EVAL IO.GetLine();
        END;
      END;

      (* Versuche Element in Baum einzufuegen, abbrechen bei Fehler *)
      TRY
        BinaryTree.insert(tree, x);IO.Put("\n");
      EXCEPT
          | BinaryTree.WrongData => IO.Put("Wert bereits vorhanden.\n");
      END;

    | '2' =>

      (* Wiederhole bis Erfolg: zu loeschendes Element einlesen *)
      LOOP
        IO.Put("\nBitte geben sie das zu loeschende Element ein: ");
        TRY
          x:= IO.GetInt();
          EVAL IO.GetLine();
          EXIT
        EXCEPT
          | IO.Error => IO.Put("Ungueltiger Wert.\n");
            EVAL IO.GetLine();
        END;
      END;

      (* Suche Element und versuche Element zu entfernen, *)
      (* abbrechen bei Fehler.                            *)
      TRY
        BinaryTree.delete(tree, BinaryTree.search(tree, x));
      EXCEPT
          | BinaryTree.Empty => IO.Put("Baum leer.\n");
          | BinaryTree.WrongData => IO.Put("Wert nicht vorhanden.\n");
      END;

    | '3' =>

      (* Wiederhole bis Erfolg: zu suchendes Element einlesen *)
      LOOP
        IO.Put("\nBitte geben sie das zu suchende Element ein: ");
        TRY
          x:= IO.GetInt();
          EVAL IO.GetLine();
          EXIT
        EXCEPT
          | IO.Error => IO.Put("Ungueltiger Wert.\n");
            EVAL IO.GetLine();
        END;
      END;
      
      (* Suche Element im Baum, abbrechen bei Fehler. *)
      TRY
        element:= BinaryTree.search(tree, x);
        IO.Put("\nElement gefunden: ");IO.PutInt(element^.key);IO.Put("\n");
      EXCEPT
          | BinaryTree.Empty => IO.Put("Baum leer.\n");
          | BinaryTree.WrongData => IO.Put("Wert nicht vorhanden.\n");
      END;
      
    | '4' =>

      (* Suche Maxmimum im Baum und gib es aus, abbrechen bei Fehler. *)
      TRY
        element:= BinaryTree.minimum(tree);
        IO.Put("\nElement gefunden: ");IO.PutInt(element^.key);IO.Put("\n");
      EXCEPT
          | BinaryTree.Empty => IO.Put("Baum leer.\n");
      END;

    | '5' =>

      (* Suche Minimum im Baum und gib es aus, abbrechen bei Fehler. *)
      TRY
        element:= BinaryTree.maximum(tree);
        IO.Put("\nElement gefunden: ");IO.PutInt(element^.key);IO.Put("\n");
      EXCEPT
          | BinaryTree.Empty => IO.Put("Baum leer.\n");
      END;

    | '6' =>

      (* Versuche Baum auszugeben, abbrechen bei Fehler. *)
      TRY
        BinaryTree.put(tree);
      EXCEPT
          | BinaryTree.Empty => IO.Put("Baum leer.\n");
      END;

    ELSE
    END; (*CASE*)
  END;   (*LOOP*)

END Main.